<?php
	// vim:ts=2 sts=2 sw=2
	// $Id$

	/*
	* PukiWiki SakuraScript BBS plugin
	* Copyright (C) 2005, yukaya <yukaya+pukiwiki-plugin@tarenari.jp>
	* SVG concept by TJ <Joe at ps dot sakura dot ne dot jp>

	׷ : sakurascript.inc.php ɬפǤ

	based by comment.inc.php,v 1.35
  Copyright (C)
    2002-2005 PukiWiki Developers Team
    2001-2002 Originally written by yu-ji
  License: GPL v2 or (at your option) any later version
	*/

define('PLUGIN_SSCOMMENT_DIRECTION_DEFAULT', '1'); // 1: above 0: below
define('PLUGIN_SSCOMMENT_SIZE_MSG',  70);
define('PLUGIN_SSCOMMENT_SIZE_NAME', 15);

// ----
define('PLUGIN_SSCOMMENT_FORMAT_MSG',  '$msg');
define('PLUGIN_SSCOMMENT_FORMAT_NAME', '[[$name]]');
define('PLUGIN_SSCOMMENT_FORMAT_NOW',  '&new{$now};');
define('PLUGIN_SSCOMMENT_FORMAT_STRING', "\x08NAME\x08 \x08NOW\x08 \x08MSG\x08");

define('PLUGIN_SSCOMMENT_GHOST_LABEL', 'GHOST: '); // label for ghost list

// ȥꥹȡɽ̾ => ǥ쥯ȥ̾
global $_plugin_sscomment_ghost_list;
$_plugin_sscomment_ghost_list = array (
	'ߥ' => 'emily4',
	'' => 'daru',
	//'' => 'dot_sakura',
	'ǥ' => 'dv',
	//'ū' => 'fuu',
	'²' => 'kazune',
	'' => 'kina',
	'Υ' => 'konoha',
	'Τ' => 'konomi',
	'꡼' => 'lily',
	'' => 'maiko',
	'Ĺ' => 'ponapalt',
	'' => 'sanada_yukimi',
	'ƻ' => 'syoko',
	'Ȥ' => 'tj',
	'ĤФ' => 'tubaki',
	'ͳ' => 'yuka',
	'ͼ' => 'yuuna_rin'
);

function plugin_sscomment_action()
{
	global $script, $vars, $now, $_title_updated, $_no_name;
	global $_msg_comment_collided, $_title_comment_collided;

	if (PKWK_READONLY) die_message('PKWK_READONLY prohibits editing');

	if (! isset($vars['msg'])) return array('msg'=>'', 'body'=>''); // Do nothing

	$vars['msg'] = str_replace("\n", '', $vars['msg']); // Cut LFs
	$head = '';
	$match = array();
	if (preg_match('/^(-{1,2})-*\s*(.*)/', $vars['msg'], $match)) {
		$head        = & $match[1];
		$vars['msg'] = & $match[2];
	}
	if ($vars['msg'] == '') return array('msg'=>'', 'body'=>''); // Do nothing
	$ghost_select = $vars['ghost_select'];

	$sscomment  = str_replace('$msg', $vars['msg'], PLUGIN_SSCOMMENT_FORMAT_MSG);
	$sscomment  = '&sakurascript(' . $ghost_select . '){' . $sscomment . '};';
	if(isset($vars['name']) || ($vars['nodate'] != '1')) {
		$_name = (! isset($vars['name']) || $vars['name'] == '') ? $_no_name : $vars['name'];
		$_name = ($_name == '') ? '' : str_replace('$name', $_name, PLUGIN_SSCOMMENT_FORMAT_NAME);
		$_now  = ($vars['nodate'] == '1') ? '' :
			str_replace('$now', $now, PLUGIN_SSCOMMENT_FORMAT_NOW);
		$sscomment = str_replace("\x08MSG\x08",  $sscomment, PLUGIN_SSCOMMENT_FORMAT_STRING);
		$sscomment = str_replace("\x08NAME\x08", $_name, $sscomment);
		$sscomment = str_replace("\x08NOW\x08",  $_now,  $sscomment);
	}
	$sscomment = '>' . $head . ' ' . $sscomment;

	$postdata    = '';
	$sscomment_no  = 0;
	$above       = (isset($vars['above']) && $vars['above'] == '1');
	foreach (get_source($vars['refer']) as $line) {
		if (! $above) $postdata .= $line;
		if (preg_match('/^#sscomment/i', $line) && $sscomment_no++ == $vars['sscomment_no']) {
			if ($above) {
				$postdata = rtrim($postdata) . "\n" .
					$sscomment . "\n" .
					"\n";  // Insert one blank line above #commment, to avoid indentation
			} else {
				$postdata = rtrim($postdata) . "\n" .
					"\n" . // Insert one blank line below #commment, too (only by design)
					$sscomment; // "\n" is already there or EOF
			}
		}
		if ($above) $postdata .= $line;
	}

	$title = $_title_updated;
	$body = '';
	if (md5(@join('', get_source($vars['refer']))) != $vars['digest']) {
		$title = $_title_comment_collided;
		$body  = $_msg_comment_collided . make_pagelink($vars['refer']);
	}

	page_write($vars['refer'], $postdata);

	$retvars['msg']  = $title;
	$retvars['body'] = $body;

	$vars['page'] = $vars['refer'];

	return $retvars;
}

function plugin_sscomment_convert()
{
	global $vars, $digest, $_btn_comment, $_btn_name, $_msg_comment;
	static $numbers = array();
	static $sscomment_cols = PLUGIN_SSCOMMENT_SIZE_MSG;
	global $_plugin_sscomment_ghost_list;

	if (PKWK_READONLY) return ''; // Show nothing

	if (! isset($numbers[$vars['page']])) $numbers[$vars['page']] = 0;
	$sscomment_no = $numbers[$vars['page']]++;

	$options = func_num_args() ? func_get_args() : array();
	if (!in_array('noname', $options)) {
		$nametags = '<label for="_p_sscomment_name_' . $sscomment_no . '">' .
			$_btn_name . '</label>' .
			'<input type="text" name="name" id="_p_sscomment_name_' .
			$sscomment_no .  '" size="' . PLUGIN_SSCOMMENT_SIZE_NAME .
			'" />' . "\n";
	}
	$nodate = in_array('nodate', $options) ? '1' : '0';
	$above  = in_array('above',  $options) ? '1' :
		(in_array('below', $options) ? '0' : PLUGIN_SSCOMMENT_DIRECTION_DEFAULT);

	$script = get_script_uri();
	$s_page = htmlspecialchars($vars['page']);
  $ghost_select = PLUGIN_SSCOMMENT_GHOST_LABEL;

	$string = <<<EOD
<br />
<form action="$script" method="post">
 <div>
  <input type="hidden" name="plugin" value="sscomment" />
  <input type="hidden" name="refer"  value="$s_page" />
  <input type="hidden" name="sscomment_no" value="$sscomment_no" />
  <input type="hidden" name="nodate" value="$nodate" />
  <input type="hidden" name="above"  value="$above" />
  <input type="hidden" name="digest" value="$digest" />
	$nametags
  <label for="_p_sscomment_ghost_select">$ghost_select</label>
	<select name="ghost_select" size="1" id="_p_sscomment_ghost_select">

EOD;

	foreach($_plugin_sscomment_ghost_list as $_label => $_dir) {
		$string .= <<<EOD
  <option value="$_dir">$_label</option>

EOD;
	}

	$string .= <<<EOD
	</select><br />
  <label for="_p_sscomment_comment_$sscomment_no">$_msg_comment</label>
  <input type="text"   name="msg" id="_p_sscomment_comment_{$sscomment_no}" size="$sscomment_cols" />
  <input type="submit" name="sscomment" value="$_btn_comment" />
 </div>
</form>
EOD;

	return $string;
}
?>
